<?php
namespace plugins\file_manager\services;

use plugins\file_manager\library\exceptions;

class CreateFile {

    private $filename;

    public function __construct( $filename ) {
        $this->filename = $filename;
    }

    public function perform( $listener ) {
        if ( !is_writable( dirname( $this->filename ) ) ) {
            throw new exceptions\DirectoryNotWritableException( sprintf( 'The directory %s is not writable.', dirname( $this->filename ) ) );
        }
        if ( file_exists( $this->filename ) ) {
            throw new exceptions\FileExistsException( sprintf( 'The file %s already exists.', $this->filename ) );
        }
        if ( !touch( $this->filename ) ) {
            throw new \RuntimeException( sprintf( 'Unable to create the file %s.', $this->filename ) );
        }
        return $this->filename;
    }
}
