<?php
namespace plugins\file_manager\services;
use plugins\file_manager\library\exceptions;

class RenameFile {

    private $oldname;
    private $newname;

    public function __construct( $oldname, $newname ) {
        $this->oldname = $oldname;
        $this->newname = $newname;
    }

    public function perform( $listener ) {
        if ( !file_exists( $this->oldname ) ) {
            throw new exceptions\FileNotFoundException( sprintf( 'The file %s does not exist.', $this->oldname ) );
        }
        if ( file_exists( $this->newname ) ) {
            throw new exceptions\FileExistsException( sprintf( 'The file %s already exists.', dirname( $this->newname ) ) );
        }
        if ( !is_writable( $this->oldname ) ) {
            throw new exceptions\FileNotWritableException( sprintf( 'The file %s is not writable.', $this->oldname ) );
        }
        if ( !rename( $this->oldname, $this->newname ) ) {
            throw new \RuntimeException( 'Could not rename file %d.', $this->oldname );
        }
        return $this->newname;
    }
}
